Unit DE28RP_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc;

procedure DE28RP(M :Integer; IORDER :Integer; ALP :Real;
                var DF :Array of Real);

implementation

procedure DE28RP(M :Integer; IORDER :Integer; ALP :Real;
                var DF :Array of Real);
var
I,J,L,L1 :Integer;
R :Real;
C :Array [0..9] of Real;
const
A1 :Real = 0.3333333333333333e0;
A2 :Real = 1.571428571428571e0;
A3 :Real = 0.5833333333333333e0;
label
_1,_2,_3,_4,_5,_6,_7,_8;
begin
if ( ALP = 1.0 ) 
 then goto _8;
if ( ALP = 0.5 ) 
 then goto _6;
if ( ALP = 2.0 ) 
 then goto _5;
C[0] := ALP*ALP;
if ( IORDER = 2 ) 
 then goto _1;
C[1] := -C[0]*(ALP-1.0)*0.5;
C[2] := C[0]*ALP;
if ( IORDER = 3 ) 
 then goto _1;
C[3] := -C[1]*(ALP-2.0)*A1;
C[4] := -C[2]*(ALP-1.0);
C[5] := C[2]*ALP;
if ( IORDER = 4 ) 
 then goto _1;
C[6] := -C[3]*(ALP-3.0)*0.25;
C[7] := -C[4]*(ALP-A2)*A3;
C[8] := -C[5]*(ALP-1.0)*1.5;
C[9] := C[5]*ALP;
_1:
for I:=1 to M do
 begin
  DF[(I-1)+0*M] := DF[(I-1)+0*M]*ALP;
  for J:=2 to IORDER do
   begin
    R := 0;
    for L:=J to IORDER do
     begin
      L1 := (L-1)*(L-2) div 2+J-1;
      R := R+DF[(I-1)+(L-1)*M]*C[L1-1];
_2:
     end;
    DF[(I-1)+(J-1)*M] := R;
_3:
   end;
_4:
 end;
goto _8;
_5:
C[0] := 4.0;
if ( IORDER = 2 ) 
 then goto _1;
C[1] := -2.0;
C[2] := 8.0;
if ( IORDER = 3 ) 
 then goto _1;
C[3] := 0.0;
C[4] := -8.0;
C[5] := 16.0;
if ( IORDER = 4 ) 
 then goto _1;
C[6] := 0.0;
C[7] := 2.0;
C[8] := -24;
C[9] := 32.0;
if ( IORDER = 5 ) 
 then goto _1;
_6:
for I:=1 to M do
 begin
  DF[(I-1)+4*M] := DF[(I-1)+4*M]*0.03125;
  DF[(I-1)+3*M] := DF[(I-1)+3*M]*0.0625+DF[(I-1)+4*M]*1.5;
  DF[(I-1)+2*M] := DF[(I-1)+2*M]*0.125+DF[(I-1)+3*M]-DF[(I-1)+4*M]*0.25;
  DF[(I-1)+1*M] := DF[(I-1)+1*M]*0.25+DF[(I-1)+2*M]*0.5;
  DF[(I-1)+0*M] := DF[(I-1)+0*M]*0.5;
_7:
 end;
_8:
end;

end.
